//---------------------------------------------------------------------------

#ifndef TetraH
#define TetraH
#include "Disp.h"
#include "Vector.h"
#include "Matrix.h"
Display * disp;
class Tetra
{
  Vector Loc,e1,e2,e3;
  public:
  Tetra(Vector a_Loc,
        Vector a_e1,
        Vector a_e2,
        Vector a_e3)
        {
           Loc=a_Loc;
           e1=a_e1;
           e2=a_e2;
           e3=a_e3;
        }
   void Show()
   {
      disp->MoveTo(Loc.x,Loc.y);
      disp->LineTo(e1.x,e1.y);
      disp->MoveTo(Loc.x,Loc.y);
      disp->LineTo(e2.x,e2.y);
      disp->MoveTo(Loc.x,Loc.y);
      disp->LineTo(e3.x,e3.y);
      disp->MoveTo(e1.x,e1.y);
      disp->LineTo(e2.x,e2.y);
      disp->LineTo(e3.x,e3.y);
      disp->LineTo(e1.x,e1.y);
   }
   void Transform(Matrix & M)
   {
      Loc=M*Loc;
      e1=M*e1;
      e2=M*e2;
      e3=M*e3;
   }
};
//---------------------------------------------------------------------------
#endif
