//---------------------------------------------------------------------------
#ifndef display_clH
#define display_clH
//---------------------------------------------------------------------------

#ifndef DisplayH
#define DisplayH
//---------------------------------------------------------------------------
#endif

class Display
{
 int x_org,y_org,W,H;
 double dx,dy;
 TCanvas * Canva;
public:
 Display(int ax_org,
         int ay_org,
         int aW,
         int aH,
         double adx,
         double ady,
         TCanvas * aCanva)
 {
   x_org=ax_org;
   y_org=ay_org;
   W=aW;
   H=aH;
   dx=adx;
   dy=ady;
   Canva=aCanva;
 };
 int Convx2xs(double x)
 {
   int xs;
   xs=x_org+x/dx;
   return xs;
 };
 int Convy2ys(double y)
 {
   int ys;
   ys=y_org+y/dy;
   return ys;
 };
 void MoveTo(double x,double y)
 {
   Canva->MoveTo(Convx2xs(x),Convy2ys(y));
 };
 void LineTo(double x,double y)
 {
    Canva->LineTo(Convx2xs(x),Convy2ys(y));
 };
 void Clear()
 {
   Canva->Brush->Color=clWhite;
   TRect rect;
   rect.right=H;
   rect.bottom=W;
   rect.left=0;
   rect.top=0;
   Canva->FillRect(rect);
 };
};
//---------------------------------------------------------------------------
#endif
