//---------------------------------------------------------------------------

#ifndef TORH
#define TORH
#include "Disp.h"
#include "Vector.h"
#include "Matrix.h"
#include "math.h"

#define N 50 //    
#define n 20 //    
#define r 2   //   
#define R 7   //  

Display * disp;
class Tor
{
  int i, j;
  Vector Circle[n], Ver[N][n];
  double fi;

  public:

//--- Tor ---
  Tor()
        {
          //   
          fi = (2*M_PI)/n;
          for (i=0; i<n; i++)
              {
               Circle[i] = Vector(0, r*cos(i*fi), r*sin(i*fi)+R);
              }

          //   
          fi = (2*M_PI)/N;
          //,     
          Vector w(0, 1, 0);
          w=w/(!w);
          for (j=0; j<N; j++)
              {
               //     w
               Matrix B=Rotate(w, j*fi); 
               //    
               for (i=0; i<n; i++)
                   {
                    Ver[j][i]=B*Circle[i];
                   }
              }
          }

//--- Show ---

      void Show()
   {

     disp->MoveTo(Ver[0][0].x, Ver[0][0].y);
     for (j=0; j<N; j++)
         {
     //  
          for (i=0; i<n; i++)
              {
               disp->LineTo(Ver[j][i].x, Ver[j][i].y);
              }
          disp->LineTo(Ver[j][0].x, Ver[j][0].y);
     //  
          if (j<N-1) {
                    for (i=0; i<n; i++)
                        {
                         disp->MoveTo(Ver[j][i].x, Ver[j][i].y);
                         disp->LineTo(Ver[j+1][i].x, Ver[j+1][i].y);
                        }
                   }
         }
     //   
          for (i=0; i<n; i++)
              {
               disp->MoveTo(Ver[N-1][i].x, Ver[N-1][i].y);
               disp->LineTo(Ver[0][i].x, Ver[0][i].y);
              }
   }

//--- Transform ---

   void Transform(Matrix & M)
   {

     for (j=0; j<N; j++)
         for (i=0; i<n; i++)
             {
              Ver[j][i]=M*Ver[j][i];
             }
      Matrix M1=M;
      M1.Invert();
      M1.Transpose();

   }




};
//---------------------------------------------------------------------------
#endif
